const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const drugClassificationService = require('./drugClassification.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new drugClassification
 * @param {Object} req.body - The drugClassification data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created drugClassification
 */
function create(req, res, next) {
    drugClassificationService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all drugClassifications
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of drugClassifications
 */
function getAll(req, res, next) {
    drugClassificationService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of drugClassification objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of drugClassification objects
 */
function option(req, res, next) {
    drugClassificationService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of drugClassifications matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of drugClassifications
 */
function count(req, res, next) {
    drugClassificationService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing drugClassification
 * @param {number} req.params.id - The drugClassification ID to be updated
 * @param {Object} req.body - The drugClassification data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated drugClassification
 */
function update(req, res, next) {
    drugClassificationService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a drugClassification
 * @param {number} req.params.id - The drugClassification ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    drugClassificationService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
